var AAO_URL_PART_ATCBRIDGE = "http://localhost:";
var lastAgentMessage = "";
var myLastMessage = "";
var lastatisfreq = 0;
var currentStringOptions = [];
var currentArrayOptions = [];
var currentAgent = "";
var currentPilot = "";
var currentAtis = "";
var aaoatcupatecount = 0;

function ResetAtcCall() {
	var apiport_atcbridge = SimVar.GetSimVarValue('L:AaoWebapiport', 'Number');
	if (apiport_atcbridge > 1) {
		var AAORequestObj = {};
		AAORequestObj.setvars = [];
		var toset = { "var": "(L:ATC_CALL)", "value": 0 };
		AAORequestObj.setvars.push(toset);
		var url = encodeURI(AAO_URL_PART_ATCBRIDGE + apiport_atcbridge.toString() + '/webapi/');
		var dataxhttp = new XMLHttpRequest();
		dataxhttp.timeout = 250;
		dataxhttp.open("POST", url);
		dataxhttp.send(JSON.stringify(AAORequestObj));
	}
}

function ResetAtcSend() {
	var apiport_atcbridge = SimVar.GetSimVarValue('L:AaoWebapiport', 'Number');
	if (apiport_atcbridge > 1) {
		var AAORequestObj = {};
		AAORequestObj.setvars = [];
		var toset = { "var": "(L:ATC_SEND)", "value": 0 };
		AAORequestObj.setvars.push(toset);
		var url = encodeURI(AAO_URL_PART_ATCBRIDGE + apiport_atcbridge.toString() + '/webapi/');
		var dataxhttp = new XMLHttpRequest();
		dataxhttp.timeout = 250;
		dataxhttp.open("POST", url);
		dataxhttp.send(JSON.stringify(AAORequestObj));
	}
}

class AaoATCListener extends ViewListener.ViewListener {
	onUpdateDialogs(callback) {
		this.on("UpdateATCDialogsData", callback);
	}
	onUpdateATCData(callback) {
		this.on("UpdateATCAllData", callback);
	}
	onUpdatePromptAndOptions(callback) {
		this.on("UpdateATCPromptAndOptionsData", callback);
	}
	onUpdateATISData(callback) {
		this.on("UpdateATCATISData", callback);
	}
}
function RegisterAaoATCListener(callback) {
	return RegisterViewListenerT("JS_LISTENER_ATC", callback, AaoATCListener);
}

class IngamePanelAaoAtcBridge extends TemplateElement {
	constructor() {
		super(...arguments);
		this.updateLoop = () => {
			aaoatcupatecount++;
			if (aaoatcupatecount > 50)
			{
				aaoatcupatecount = 0;
				var AAORequestObj = {};
				AAORequestObj.setstringvars = [];
				AAORequestObj.scripts = [];
				for (let i = 0; i < currentStringOptions.length; i++)
				{
					AAORequestObj.setstringvars.push(currentStringOptions[i]);
					AAORequestObj.scripts.push(currentArrayOptions[i]);
				}
				this.SendRequest(AAORequestObj);
			}
			requestAnimationFrame(this.updateLoop);
		};
		this.onShow = () => {

		};
		this.onHide = () => {

		};
		this.panelActive = false;
		this.started = false;
		this.ingameUi = null;
		this.closeButton = null;
		this.busy = false;
		this.debugEnabled = false;
		this.initialize();
	}
	isDebugEnabled() {
	}
	connectedCallback() {
		super.connectedCallback();
		this.onUpdateDialogs = (data) => {
			this.SetDialogsDatas(data);
		};
		this.onDataUpdate = (data) => {
			this.SetDialogsDatas(data);
			this.SetPromptAndOptionsData(data);
			// this.SetATISDatas(data);
		};
		this.onUpdateOptions = (data) => {
			this.SetATISDatas(data);
			this.SetPromptAndOptionsData(data);
		};
		this.onUpdateATISData = (data) => {
			lastatisfreq = data.CurrentRadio.ActiveFrequency;
			this.SetATISDatas(data);
		};
		this.ingameUi = document.getElementById("LorbyAtcBridge");
		if (this.ingameUi) {
			this.ingameUi.style.display = "none";
		}
		this.AaoATCListener = RegisterAaoATCListener(() => {
			requestAnimationFrame(this.updateLoop);
		});
		this.RegisterATCCallbacks();
	}
	RegisterATCCallbacks() {
		this.AaoATCListener.onUpdateDialogs(this.onUpdateDialogs);
		this.AaoATCListener.onUpdateATCData(this.onDataUpdate);
		this.AaoATCListener.onUpdatePromptAndOptions(this.onUpdateOptions);
		this.AaoATCListener.onUpdateATISData(this.onUpdateATISData);
	}
	SetDialogsDatas(data) {
		if (data.Dialogs.length > 0) {
			let currentData = data.Dialogs[data.Dialogs.length - 1];
			if (currentData.Message.length != 0) {
				if (currentData.Type == 1) {
					if (lastAgentMessage !== currentData.Message) {
						let tio = currentData.Message.length / 8 * 1000;
						if (tio < 5000)
							tio = 5000;
						setTimeout(ResetAtcCall, tio);
						lastAgentMessage = currentData.Message;
						var AAORequestObj = {};
						AAORequestObj.setstringvars = [];
						AAORequestObj.setvars = [];
						var toset = { "var": "(L:ATC_AGENT, String)", "value": currentData.Message };
						AAORequestObj.setstringvars.push(toset);
						toset = { "var": "(L:ATC_CALL)", "value": 1 };
						AAORequestObj.setvars.push(toset);
						this.SendRequest(AAORequestObj);
					}
				} else {
					if (currentData.Type == 2) {
						if (myLastMessage !== currentData.Message) {
							myLastMessage = currentData.Message;
							let tio = currentData.Message.length / 8 * 1000;
							if (tio < 5000)
								tio = 5000;
							setTimeout(ResetAtcSend, tio);
							var AAORequestObj = {};
							AAORequestObj.setstringvars = [];
							AAORequestObj.setvars = [];
							var toset = { "var": "(L:ATC_PILOT, String)", "value": currentData.Message };
							AAORequestObj.setstringvars.push(toset);
							toset = { "var": "(L:ATC_SEND)", "value": 1 };
							AAORequestObj.setvars.push(toset);
							this.SendRequest(AAORequestObj);
						}
					}
				}
			}
		}
	}
	SetPromptAndOptionsData(data) {
		var AAORequestObj = {};
		AAORequestObj.setstringvars = [];
		AAORequestObj.scripts = [];
		var pstr = data.Prompt;
		if (!pstr.includes(data.CurrentRadio.ActiveFrequency.toFixed(3)))
			pstr = "On frequency " + data.CurrentRadio.ActiveFrequency.toFixed(3);
		var toset = { "var": "(L:ATC_PROMPT, String)", "value": pstr };
		AAORequestObj.setstringvars.push(toset);
		var tidx = [];
		if (data.Options.length > 0) {
			for (var i = 0; i < data.Options.length; i++) {
				if (data.Options[i].length != 0) {
					const regex = /(\d){1} - (.*)/g;
					let result = regex.exec(data.Options[i]);
					toset = { "var": "(L:ATC_OPTION_" + result[1] + ", String)", "value": result[2] };
					AAORequestObj.setstringvars.push(toset);
					currentStringOptions[parseInt(result[1])] = toset;
					tidx.push(result[1]);
					
					if (toset.value.includes("Tune") && toset.value.includes("ATIS")) {
						toset = { "var": "(L:ATC_ATIS, String)", "value": "" };
						AAORequestObj.setstringvars.push(toset);
					}
					let arrscr = "\'" + result[2] + "\'" + " (STRARR:ATC_MENU:10) " + result[1] + " set";
					toset = { "code": arrscr };
					currentArrayOptions[parseInt(result[1])] = toset;
					AAORequestObj.scripts.push(toset);
				}
			}
			for (var i = 0; i < 10; i++) {
				if (!tidx.includes(i.toString())) {
					toset = { "var": "(L:ATC_OPTION_" + i + ", String)", "value": "" };
					AAORequestObj.setstringvars.push(toset);
					currentStringOptions[i] = toset;
					let arrscr = "\'\'" + " (STRARR:ATC_MENU:10) " + i + " set";
					toset = { "code": arrscr };
					currentArrayOptions[i] = toset;
					AAORequestObj.scripts.push(toset);
				}
			}
			this.SendRequest(AAORequestObj);
		}
		
	}
	SetATISDatas(data) {
		if (data.Options.length == 0 || lastatisfreq != data.CurrentRadio.ActiveFrequency)
			return;
		var AAORequestObj = {};
		AAORequestObj.setstringvars = [];
		var toset = { "var": "(L:ATC_ATIS, String)", "value": data.LastATISMessage };
		AAORequestObj.setstringvars.push(toset);
		this.SendRequest(AAORequestObj);
	}

	SendRequest(requestObject){
		var apiport_atcbridge = SimVar.GetSimVarValue('L:AaoWebapiport', 'Number');
		if (apiport_atcbridge > 1) {
			var url = encodeURI(AAO_URL_PART_ATCBRIDGE + apiport_atcbridge.toString() + '/webapi/');
			var dataxhttp = new XMLHttpRequest();
			dataxhttp.timeout = 250;
			dataxhttp.open("POST", url);
			dataxhttp.send(JSON.stringify(requestObject));
		}
	}
	initialize() {
		if (this.started) {
			return;
		}
		this.started = true;
		ResetAtcSend();
		ResetAtcCall();
	}
	disconnectedCallback() {
		super.disconnectedCallback();
	}
}
window.customElements.define("ingamepanel-aaoatcbridge", IngamePanelAaoAtcBridge);
checkAutoload();